<?php

namespace CRM\Service;

use CRM\Factory\CrmOrganizacaoPorOperadorFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmOrganizacaoPorOperadorService
{

    protected $OrganizacaoPorOperadorFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $Environment, NewCode $newCode, EntityManager $entityManager, CrmOrganizacaoPorOperadorFactory $OrganizacaoPorOperadorFactory)
    {
        $this->OrganizacaoPorOperadorFactory    = $OrganizacaoPorOperadorFactory;
        $this->Environment                      = $Environment;
        $this->newCode                          = $newCode;
        $this->connection                       = $entityManager->getConnection();
    }

    public function getCrmOrganizacaoPorOperador()
    {

        return $this->OrganizacaoPorOperadorFactory->getCrmOrganizacaoPorOperador();
    }


    public function getOrgOrganizacaoPorOperador()
    {
    
        return $this->OrganizacaoPorOperadorFactory->getOrgOrganizacaoPorOperador();
    }


    public function saveOrgOganizacao($row)
    { 

       $this->connection->beginTransaction();
       try{

            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();
            $novoCodigo = $this->newCode->getCodeByTableName("CRM_ORGANIZACAO", $nrorg, 1, 5, false);
            $params = array(
                "CRM_NRORGTRAB"     => $novoCodigo,
                "NMORGTRAB"         => $row["NMORGTRAB"],
                "IDATIVO"           => $row["IDATIVO"],
                "DSORG"             => $row["DSORG"],
                "NRORG"             => $nrorg,
                "NRORGINCLUSAO"     => $nrorg,
                "CDOPERINCLUSAO"    => $operador,
            );

            $this->OrganizacaoPorOperadorFactory->insertOrgOganizacao($params);
            $this->connection->commit();
        } catch (\Exception $ex) {
            $this->connection->rollback();
                throw $ex;
        }
    }


    public function saveEditOrgOganizacao($row)
    {
        // $this->checkExistingOrgOrganizacao($nrorg, $row);
        $nrorg = $this->Environment->getNrorg();
        $operador = $this->Environment->getCdOperador();
         $params = array(
             "CRM_NRORGTRAB"     => $row["CRM_NRORGTRAB"],
             "NMORGTRAB"         => $row["NMORGTRAB"],
             "IDATIVO"           => $row["IDATIVO"],
             "DSORG"             => $row["DSORG"],
             "NRORG"             => $nrorg,
             "NRORGULTATU"       => $nrorg,
             "CDOPERULTATU"      => $operador,

         ); 

         $this->OrganizacaoPorOperadorFactory->editOrgOganizacao($params);
        }

    public function deleteOrgOganizacao ($params)
    {
        $this->connection->beginTransaction();
        try {
            $nrorg = $this->Environment->getNrOrg();

            foreach ($params["NRS"] as $item) {

                $params = array(
                    "CRM_NRORGTRAB"       =>  $item["CRM_NRORGTRAB"],
                    "NMORGTRAB"           =>  $item["NMORGTRAB"],
                    "NRORG"               => $nrorg,
                );

                $this->OrganizacaoPorOperadorFactory->deleteOrgOganizacao ($params);
            }

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }




    public function saveOperOganizacao($row)
    { 

       $this->connection->beginTransaction();
       try{
        $nrorg = $this->Environment->getNrorg();
        $operador = $this->Environment->getCdOperador();

            if ($row["CDOPERADOR"] == $operador) {
                $this->checkExistingOperOrganizacao($nrorg, $row);
                    $params = array(
                    "CDOPERADOR"        => $row["CDOPERADOR"],
                    "NRORG"             => $nrorg,
                    "CRM_NRORGTRAB"     => $row["CRM_NRORGTRAB"],
                    "NMOPERADOR"        => $row["NMOPERADOR"],
                    "IDATIVO"           => $row["IDATIVO"],
                    "DTINCLUSAO"        => $row["DTINCLUSAO"],
                    "NRORGINCLUSAO"     => $nrorg,
                    "CDOPERINCLUSAO"    => $operador,
                );

                $this->OrganizacaoPorOperadorFactory->insertOperOganizacao($params);
            } else {
                //$this->checkExistingOperOrganizacao($nrorg, $row);
                $params = array(
                    "CDOPERADOR"        => $row["CDOPERADOR"],
                    "NRORG"             => $nrorg,
                    "CRM_NRORGTRAB"     => $row["CRM_NRORGTRAB"],
                    "NRORGINCLUSAO"     => $nrorg,
                    "CDOPERINCLUSAO"    => $operador,
                );
            }
                $this->connection->commit();
            } catch (\Exception $ex) {
                $this->connection->rollback();
                throw $ex;
        }
    }





}